
function getParameterByName(name, url) {
    if (!url) url = window.location.href;
    name = name.replace(/[\[\]]/g, "\\$&");
    var regex = new RegExp("[?&]" + name + "(=([^&#]*)|&|#|$)"),
        results = regex.exec(url);
    if (!results) return null;
    if (!results[2]) return '';
    return decodeURIComponent(results[2].replace(/\+/g, " "));
}

(function() {
    var header = new Headroom(document.querySelector("#header"), {
        tolerance: 5,
        offset : 205,
        classes: {
          initial: "animated",
          pinned: "headroom--pinned",
          unpinned: "headroom--unpinned"
        }
    });
    header.init();
}()); 

var crrURL = window.location.href
if (typeof(Storage) !== "undefined" && crrURL.indexOf("goBack") == -1) {
    var localStorageURL = localStorage.getItem("lastURL")
    if(localStorageURL != null && localStorageURL != "") {
        var l = localStorageURL
        if (window.location != l) {
            window.location.href = l
            localStorage.setItem("lastURL", "")
        }
    }
}

var currentPath = getParameterByName('q', url)
currentPath = currentPath == null ? "" : currentPath + "/"
var ljson = "filelist.json"
var url = "https://static.soundcorset.com/score/" + currentPath + ljson
var qParemeter = "&q="
var enableHomeString = "?home=true"
var disableHomeString = "?home=false"
var linkHTML = "view.html"
var myScore = "My Score"

function realHomeString() {
   return containHome() == true ? enableHomeString : disableHomeString
}

function containHome() {
    return (crrURL.indexOf(enableHomeString) != -1)
}

function linkHref(v) {
    var hString = realHomeString()
    return '<a href="'+linkHTML + hString + qParemeter + currentPath + v + '" data-ajax="false">'
}

function linkHrefRow(v) {
    var hString = realHomeString() 
    return '<a href="'+linkHTML + hString + qParemeter + currentPath + v + '" class="nextBtn" data-ajax="false">'
}

function upperLink(l) {
    var realLink = l.substring(0, l.length-1)
    return realLink.substring(0, realLink.lastIndexOf('/'))
}

function paths() {
    var fullPath = currentPath
    var folderPaths = []
    while(fullPath.length > 0) {
        fullPath = fullPath.substr(0, fullPath.lastIndexOf('/'))
        folderPaths.push(fullPath)
    }
    return folderPaths.reverse()
}

function urlExists(url) {
    var http = new XMLHttpRequest()
    http.open('HEAD', url, false)
    http.send()
    return http.status!=404
}

function Get(yourUrl){
    var Httpreq = new XMLHttpRequest()
    Httpreq.open("GET",yourUrl,false)
    Httpreq.send(null)
    return Httpreq.responseText
}

function checkImgURL(url){
    return(url.match(/\.(jpeg|jpg|gif|png)$/) != null);
}

var startTime
var startDate
var endTime
function loadView() {
    if(containHome()==true) {
        var b = '<a id = "goBack" href="'+linkHTML+realHomeString()+'?goBack" class="menuBtn backBtn backBtn50" data-ajax="false"></a>'
        document.getElementById("menu").innerHTML += b
    }
    var fdPaths = paths()
    var pStr = ''
    for (var i = 0; i < fdPaths.length-1; i++) {
        var l = fdPaths[i]
        var name = l.substr(l.lastIndexOf('/') + 1, l.length)
        var h = '<a href="'+linkHTML+ realHomeString()+'?goHome" class="menuBtn homeBtn pathBtn" data-ajax="false"></a>'
        var left = 95 * i + 5
        var b = '<button onClick="location.href='+ "'" + linkHTML + realHomeString() + qParemeter + l + "'" +'" style="left: '+left+'px;" class="pathBtn" data-ajax="false">'+name+'</button>'

        var p = i == 0 ? h : b        
        pStr += p
    }
    document.getElementById("menu").innerHTML += pStr
    
    var staticPage = 'https://static.soundcorset.com/scoreView/chartScore.html'
    var timingBtn = '<a href="' + staticPage +'" class="menuBtn staticBtn" data-ajax="false">Static</a>'
    document.getElementById("menu").innerHTML += timingBtn

    var camera = '<a href="'+linkHTML+realHomeString()+'?goCamera" class="menuBtn cameraBtn" data-ajax="false">Camera</a>'
    document.getElementById("menu").innerHTML += camera
        
    if(currentPath.indexOf(myScore) != -1) {
        if(window.Android) {
            if(currentPath != myScore+'/') {
                var foName = crrURL.substring(crrURL.lastIndexOf('/') + 1).split("%20").join(' ');
                var j = JSON.parse(Android.getJson(foName))
                j.files.map(function(v, i) {
                    var l = v.name
                    if(checkImgURL(l)) {
                         var path = "file://" + l
                         document.getElementById("content").innerHTML += '<img class ="score" src="'+path+'" >'
                    }
                });
                var editBtn = '<a href="'+linkHTML+realHomeString()+'?goEdit'+foName+'" class="menuBtn" data-ajax="false">Edit</a>'
                document.getElementById("menu").innerHTML += editBtn
                }
            else {
                var output = '<table style="width:100%">'
                var files = JSON.parse(Android.getCameraFolders())
                files.map(function(v, i) {
                    var path = "file://" + v
                    var nF = v.substring(v.lastIndexOf('/') + 1)
                    var color = i % 2 != 0 ? 'bgcolor="white"' : 'bgcolor="#f1f1f1"'
                    output += '<tr '+color+'><td width = "100%">' + linkHref(nF) + nF +  '</a></td></tr>'
                });
                output += '</table>'
                document.getElementById("content").innerHTML += output
            } 
        }
    }
    else {
    var json_obj = JSON.parse(Get(url))
    var files = json_obj.files
    var value = []
    for (var i = 0; i < files.length; i++) {
        value.push(files[i].name)
    }

    var output = ''
    if (value[0].indexOf("json") > -1) {            
        startTime = new Date()
        for (i = 0; i < value.length; i++) {
            var n = value[i].replace("json", "png")
            var u = url.replace(ljson, n)
            output += '<img class="score" src="' + u + '"><br>'
        }
        document.getElementById("content").innerHTML += output
    }
    else {
        output += '<table style="width:100%">'
        var prePage = 'https://static.soundcorset.com/score/' + currentPath + value[0] + '/preview.png'
        if(urlExists(prePage)) {
            for (i = 0; i < value.length; i++) {
                var u = url.replace(ljson, "") + value[i] + '/preview.png'
                var color = i % 2 != 0 ? 'bgcolor="white"' : 'bgcolor="#f1f1f1"'
                output += '<tr '+color+'><td width = "10%">' + linkHref(value[i]) + value[i] + '</a></td>'
                output += '<td width = "90%">' + linkHref(value[i]) + '<img class ="score" src="' + u + '"> </a> </td></tr>'
            }
        }
        else {
            if(currentPath.length <= 0) { value.push(myScore) }
            for (i = 0; i < value.length; i++) {
                var color = i % 2 != 0 ? 'bgcolor="white"' : 'bgcolor="#f1f1f1"'
                output += '<tr style = "height: 50px"'+color+'><td width = "90%">' + linkHref(value[i]) + value[i] + '</a></td>'
                output += '<td width = "10%">' + linkHref(value[i]) + '<img src="https://static.soundcorset.com/scoreView/btnRow.png" style="margin-left:25%; height: 25px; width: 25px" align="middle"> </a> </td></tr>'
            }
        }
        output += '</table>'
        document.getElementById("content").innerHTML += output
    } }
}

loadView();
document.body.innerHTML += '<div class="loader"></div>'
window.onload = function () {
    $('.loader').remove()
}

$(window).on('unload ',function() {
    var start = startTime.getTime()
    if (start != 0) {
        endTime = new Date()
        var startDate = startTime.toLocaleDateString()

        var timeInterval = endTime.getTime() - startTime.getTime()
        timeInterval -= idleInterval

        var practices = JSON.parse(localStorage.getItem("practice"))
        if (practices == null) { practices = {} }
        var pDate = practices[startDate]
        if (pDate == null) { pDate = {} }
        if (pDate.hasOwnProperty(currentPath)) {
            pDate[currentPath] += timeInterval
        }
        else {
            pDate[currentPath] = timeInterval
        }
        practices[startDate] = pDate

        localStorage.setItem("practice", JSON.stringify(practices))

        localStorage.setItem("touch", idleInterval)
    }
});

var practices = JSON.parse(localStorage.getItem("practice"))
var dateKeys = Object.keys(practices)
var today = new Date()
var oldestDate = new Date(dateKeys[0])
if ( today.getTime() - oldestDate.getTime() > 30 * 24 * 60 * 60 * 1000) {
   delete practices[dateKeys[0]]
}
localStorage.setItem("practice", JSON.stringify(practices))

var currPos = getParameterByName('p', crrURL)
$('body').animate({scrollTop:currPos},1000)
$('#goBack').click(function(){
    var scrolled_val = $(document).scrollTop().valueOf()
    var lastLink = window.location.href + '&p='+scrolled_val+''
    localStorage.setItem("lastURL", lastLink)
});
